"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}var program=_interopDefault(require("commander")),chalk=_interopDefault(require("chalk")),path$1=_interopDefault(require("path")),execa=_interopDefault(require("execa")),Listr=_interopDefault(require("listr")),mkdirp=_interopDefault(require("mkdirp")),tar=_interopDefault(require("tar")),fs$1=_interopDefault(require("fs-extra")),globby=_interopDefault(require("globby")),kebabCase=_interopDefault(require("lodash/kebabCase")),flatMap=_interopDefault(require("lodash/flatMap")),inquirer=_interopDefault(require("inquirer"));const processTigerFile=async(e,a)=>{if(a){const a=e.replace(/--tiger(\..+)$/,"$1");await fs$1.remove(a),await fs$1.rename(e,a)}else await fs$1.remove(e)},processTigerFiles=async(e,a)=>{const t=path$1.posix.join(e,"./**/*--tiger.*"),r=await globby(t);return Promise.all(r.map(e=>processTigerFile(e,a)))},verboseLog=e=>{console.log(`[VERBOSE]: ${e}`)},fs=require("fs"),fsExtra=require("fs-extra"),path=require("path"),babel=require("@babel/core"),prettier=require("prettier"),TYPE_SCRIPT_FILE_REGEX=/\.ts(.?)$/,JAVA_SCRIPT_FILE_EXTENSION_REPLACEMENT=".js$1",changeFileExtensionToJs=e=>e.replace(TYPE_SCRIPT_FILE_REGEX,".js$1"),getProjectTypeScriptFiles=e=>fs.readdirSync(e).filter(e=>"node_modules"!==e).flatMap(a=>{const t=path.join(e,a);return fs.statSync(t).isDirectory()?getProjectTypeScriptFiles(t):t}).filter(e=>TYPE_SCRIPT_FILE_REGEX.test(e)),transformOptions={retainLines:!0,plugins:[["@babel/plugin-transform-typescript",{isTSX:!0,allExtensions:!0}]],presets:[["@babel/preset-env",{modules:!1,targets:{browsers:"last 1 Chrome versions"}}]]},formattingOptions={parser:"babel",printWidth:110,tabWidth:4,trailingComma:"all"},transpileTypeScriptFile=e=>{const{code:a}=babel.transformFileSync(e,transformOptions);return prettier.format(a,formattingOptions)},transpileTypeScriptFiles=async e=>getProjectTypeScriptFiles(e.targetDir).forEach(e=>{fs.writeFileSync(changeFileExtensionToJs(e),transpileTypeScriptFile(e)),fsExtra.removeSync(e)}),DEFAULT_SCHEMA="https",getSchema=e=>{const a=/^(\w+):\/\//i.exec(e);return a&&a[1]?a[1]:""},getHostnameWithSchema=e=>getSchema(e)?e:`https://${e}`,sanitizeAppName=kebabCase,parseReplacementSpecTree=(e,a)=>Array.isArray(a)?{file:e,replacements:a}:flatMap(Object.entries(a),([a,t])=>parseReplacementSpecTree(path$1.join(e,a),t)),processFile=(e,a)=>async({file:t,replacements:r})=>{const s=await e(t,{encoding:"utf8",flag:"r"}),o=r.reduce((e,{regex:a,value:t,apply:r})=>r?e.replace(a,t):e,s);return a(t,o,{encoding:"utf8",flag:"w"})},replaceInFiles=async(e,a,t=fs$1.readFile,r=fs$1.writeFile)=>Promise.all(parseReplacementSpecTree(e,a).map(processFile(t,r))),performTemplateReplacements=async({targetDir:e,sanitizedAppName:a,hostname:t,backend:r,flavor:s})=>{const o="tiger"===r,n="js"===s,i={"package.json":[{regex:/@gooddata\/gdc-app-name/,value:a,apply:!0},{regex:/@gooddata\/sdk-backend-bear/g,value:"@gooddata/sdk-backend-tiger",apply:o},{regex:/"refresh-ldm": "node .\/scripts\/refresh-ldm.js"/g,value:'"refresh-ldm": "node ./scripts/refresh-ldm.js --backend tiger"',apply:o},{regex:/"start": "cross-env HTTPS=true react-scripts start",/g,value:'"start": "react-scripts start",',apply:"https"!==(getSchema(t)||"https")},{regex:/\n.*@types\/.*/g,value:"",apply:n}],"README.md":[{regex:/constants\.ts/g,value:"constants.js",apply:n},{regex:/full\.ts/g,value:"full.js",apply:n}],"README--tiger.md":[{regex:/constants\.ts/g,value:"constants.js",apply:n},{regex:/full\.ts/g,value:"full.js",apply:n}],src:{"constants.ts":[{regex:/appName = "(.*?)"/,value:`appName = "${a}"`,apply:!0},{regex:/backend = "https:\/\/developer\.na\.gooddata\.com"/g,value:`backend = "${getHostnameWithSchema(t)}"`,apply:!0},{regex:/workspace = ""/g,value:'workspace = "workspace"',apply:o}],"setupProxy.js":[{regex:/proxy\("\/gdc"/g,value:'proxy("/api"',apply:o},{regex:/constants\.ts/g,value:"constants",apply:n}],components:{Header:{"Header.tsx":[{regex:/import Aside from ".\/Aside";\n/g,value:"",apply:o},{regex:/<Aside \/>/g,value:"",apply:o}]}},contexts:{Auth:{"backend--tiger.ts":[{regex:/constants\.ts/g,value:"constants.js",apply:n}]}},routes:{"AppRouter.tsx":[{regex:/: React\.FC/g,value:"",apply:n}],"Welcome.tsx":[{regex:/constants\.ts/g,value:"constants.js",apply:n},{regex:/full\.ts/g,value:"full.js",apply:n},{regex:/\.tsx/g,value:".jsx",apply:n}],"Welcome--tiger.tsx":[{regex:/constants\.ts/g,value:"constants.js",apply:n},{regex:/full\.ts/g,value:"full.js",apply:n},{regex:/\.tsx/g,value:".jsx",apply:n}]}},scripts:{"refresh-ldm.js":[{regex:/constants\.ts/g,value:"constants",apply:n},{regex:/full\.ts/g,value:"full.js",apply:n}],"run-testcafe.js":[{regex:/spec\.ts/g,value:"spec.js",apply:n}]}};return replaceInFiles(e,i)},getTargetDirPath=(e,a)=>path$1.resolve(a||process.cwd(),e),copyAppFiles=async({targetDir:e})=>(mkdirp(e),tar.x({file:path$1.resolve(__dirname,"bootstrap.tgz"),strip:1,cwd:e})),processFilesFlavor=async e=>{const{targetDir:a,flavor:t}=e;"js"===t?(await fs$1.remove(path$1.join(a,"tsconfig.json")),await fs$1.remove(path$1.join(a,"src","react-app-env.d.ts")),await transpileTypeScriptFiles(e)):"ts"===t&&await fs$1.remove(path$1.join(a,"jsconfig.json"))},setupApp=async e=>{await performTemplateReplacements(e),await processTigerFiles(e.targetDir,"tiger"===e.backend),await processFilesFlavor(e)},runYarnInstall=({targetDir:e,install:a})=>a?execa("yarn",{cwd:e,stdio:[process.stdin,process.stdout,process.stderr]}).then(()=>!0).catch(()=>(console.log(chalk.red("Installation failed. Please make sure that you have yarn installed and try again.")),!1)):(console.log("Skipping installation because the --no-install flag was specified"),!0),outputFinalInstructions=({sanitizedAppName:e,install:a,targetDir:t})=>{console.log(`Success! Your GoodData-powered application "${e}" was created.`),console.log("You can start it using the following commands:"),console.log(chalk.cyan(`    cd ${path$1.relative(process.cwd(),t)}`)),a||console.log(chalk.cyan("    yarn install")),console.log(chalk.cyan("    yarn start"))},main=async e=>{const a={...e,targetDir:getTargetDirPath(e.sanitizedAppName,e.targetDir)};a.verbose&&verboseLog(`Target directory: ${a.targetDir}`);const t=new Listr([{title:"Copy app files",task:()=>copyAppFiles(a)},{title:"Set up app",task:()=>setupApp(a)}]);await t.run(),await runYarnInstall(a)&&outputFinalInstructions(a)},inquireName=()=>inquirer.prompt({message:"What is your application name?",name:"name",type:"input"}).then(e=>e.name),inquireHostname=e=>inquirer.prompt([{message:"What is your hostname?",name:"hostname",type:"list",choices:[{value:"https://secure.gooddata.com"},{value:"https://developer.na.gooddata.com"},{value:"https://salesengineering.na.gooddata.com"},{name:"I have a custom hostname",value:"WHITE_LABELLED"}],when:()=>e},{message:"Insert your hostname",name:"hostname",type:"input",when:({hostname:a})=>"WHITE_LABELLED"===a||!e}]).then(e=>e.hostname),inquireFlavor=()=>inquirer.prompt({message:"What is your application desired flavor?",name:"flavor",type:"list",choices:[{name:"JavaScript",value:"js"},{name:"TypeScript",value:"ts"}]}).then(e=>e.flavor),getSanitizedAppName=async e=>{const a=e||await inquireName();if(!a)throw new Error("You must provide a name for your app");return sanitizeAppName(a)},getSanitizedFlavor=async e=>{return("ts"!==e&&"js"!==e?void 0:e)||inquireFlavor()},getBootstrapData=async(e,{hostname:a,backend:t,flavor:r})=>{return{sanitizedAppName:await getSanitizedAppName(e),hostname:a||await inquireHostname(!t||"bear"===t),flavor:await getSanitizedFlavor(r)}},parseConfig=(e,{hostname:a,appName:t,flavor:r})=>{if(!a)throw new Error("You must provide a hostname for your app");const s=sanitizeAppName(t||e);if(!s)throw new Error("You must provide a name for your app");if(void 0!==r&&"ts"!==r&&"js"!==r)throw new Error("You must provide valid flavor value");return{sanitizedAppName:s,hostname:a,flavor:r||"js"}},getBootstrapData$1=async(e,{config:a})=>{let t={};try{t=await fs$1.readJSON(a,{encoding:"utf8",flag:"r"})}catch(e){throw new Error("The config file specified using the -c option was not found. Please check that the path you provided is correct.")}return parseConfig(e,t)};process.on("unhandledRejection",e=>console.error(e.message)),program.name("@gooddata/create-react-app").arguments("[app-name]").option("--hostname <hostname>","URL of your GoodData host").option("-c, --config <config>","path to configuration file").option("--target-dir <path>",'path to the directory to create the app in (default: ".")').option("--no-install","skip yarn installing the app dependencies").option("--verbose","output additional logs, useful mainly for debugging and bug reports").option("--backend <backend>","setting backend of the app (default: bear backend)").option("--flavor <flavor>","language flavor of the app, either TypeScript (ts) or JavaScript (js), default: js").action(async e=>{const a=program.config?getBootstrapData$1:getBootstrapData,t=await a(e,program);return main({...t,install:program.install,targetDir:program.targetDir,verbose:program.verbose,backend:program.backend})}).parse(process.argv);
